import { IModel, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class ExtrudeModel extends BaseModel {
    protected texture: ITexture2D;
    getUninforms(): {
        u_topsurface: number;
        u_sidesurface: number;
        u_heightfixed: number;
        u_dataTexture: ITexture2D;
        u_cellTypeLayout: number[];
        u_raisingHeight: number;
        u_opacity: number;
        u_linearColor: number;
        u_sourceColor: number[];
        u_targetColor: number[];
        u_texture: ITexture2D;
    };
    initModels(callbackModel: (models: IModel[]) => void): void;
    buildModels(callbackModel: (models: IModel[]) => void): void;
    getShaders(): {
        frag: string;
        vert: string;
        type: string;
    };
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private loadTexture;
}
